	

RotationEvent3 = {};
RotationEvent3_mt = Class(RotationEvent3, Event);

InitEventClass(RotationEvent3, "RotationEvent3");

function RotationEvent3:emptyNew()  -- hoier wir ein leeres Event objekt erzeugt
    local self = Event:new(RotationEvent3_mt );
    self.className="RotationEvent3";
    return self;
end;

function RotationEvent3:new(vehicle, direction) -- Der konsturktor des Events (erzeugt eben ein neues Event). Wir wollen das vehicle (aufrufer) und die neue richtung speichern bzw. bertragen
    self.vehicle = vehicle;
    self.direction = direction;
    return self;
end;

function RotationEvent3:readStream(streamId, connection)  -- wird aufgerufen wenn mich ein Event erreicht
    local id = streamReadInt32(streamId); -- hier lesen wir die bertragene ID des vehicles aus
    self.direction = streamReadBool(streamId); -- hier lesen wir die neue direction aus (es handelt sich hierbei um einen Bool (true/false)
    self.vehicle = networkGetObject(id); -- wir wandeln nunn die ID des vehicles in das passende Objekt um
    self:run(connection);  -- das event wurde komplett empfangen und kann nun "ausgefhrt" werden
end;

function RotationEvent3:writeStream(streamId, connection)   -- Wird aufgrufen wenn ich ein event verschicke (merke: reihenfolge der Daten muss mit der bei readStream bereinstimmen (z.B. hier: erst die Vehicle-Id und dann die rotation senden, und bei Readstream dann eben erst die vehicleId lesen und dann die rotation)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));	-- wir bertragen das Vehicle in form seiner ID
    streamWriteBool(streamId, self.direction );   -- wir bertragen die neue direction
end;

function RotationEvent3:run(connection)  -- wir fhren das empfangene event aus
    self.vehicle:setRotateDirection4(self.direction, true); -- wir rufen die funktion setRotateDirection auf, damit auch hier bei uns die drehrichtung gendert wird. Das true ist hier wichtig, dann wir haben ein event erhalten, d.h. wir brauchen es nicht mehr versenden, weil es alle anderen mitpsieler schon erreicht hat! Das true also hier nie vergessen!!!!!!
	if not connection:getIsServer() then  -- wenn der Empfnger des Events der Server ist, dann soll er das Event an alle anderen Clients schicken
		g_server:broadcastEvent(RotationEvent3:new(self.vehicle, self.direction), nil, connection, self.object);
	end;
end;

function RotationEvent3.sendEvent(vehicle, direction, noEventSend)  -- hilfsfunktion, die Events anstte (wirde von setRotateDirection in der Spezi aufgerufen)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then   -- wenn wir der Server sind dann schicken wir das event an alle clients
			g_server:broadcastEvent(RotationEvent3:new(vehicle, direction), nil, nil, vehicle);
		else -- wenn wir ein Client sind dann schicken wir das event zum server
			g_client:getServerConnection():sendEvent(RotationEvent3:new(vehicle, direction));
		end;
	end;
end;